Index: grade/report/grader/preferences.php
=========================================================
--- grade/report/grader/preferences.php	(revision 1.25.2.2)
+++ grade/report/grader/preferences.php	Thu Apr 16 09:31:42 CEST 2009
@@ -44,12 +44,8 @@
 require('preferences_form.php');
 $mform = new grader_report_preferences_form('preferences.php', compact('course'));
 
-if ($mform->is_cancelled()){
-    redirect($CFG->wwwroot . '/grade/report/grader/index.php?id='.$courseid);
-}
-
 // If data submitted, then process and store.
-if ($data = $mform->get_data()) {
+if (!$mform->is_cancelled() && $data = $mform->get_data()) {
     foreach ($data as $preference => $value) {
         if (substr($preference, 0, 6) !== 'grade_') {
             continue;
@@ -66,21 +62,11 @@
     exit;
 }
 
-$strgrades = get_string('grades');
-$strgraderreport = get_string('modulename', 'gradereport_grader');
-$strgradepreferences = get_string('gradepreferences', 'grades');
-
-$navigation = grade_build_nav(__FILE__, $strgradepreferences, $courseid);
-
-print_header_simple($strgrades.': '.$strgraderreport . ': ' . $strgradepreferences,': '.$strgradepreferences, $navigation,
-                    '', '', true, '', navmenu($course));
-
-/// Print the plugin selector at the top
-print_grade_plugin_selector($course->id, 'report', 'grader');
+if ($mform->is_cancelled()){
+    redirect($CFG->wwwroot . '/grade/report/grader/index.php?id='.$courseid);
+}
 
-// Add tabs
-$currenttab = 'preferences';
-include('tabs.php');
+print_grade_page_head($courseid, 'preferences', 'grader', get_string('preferences', 'gradereport_grader'));
 
 // If USER has admin capability, print a link to the site config page for this report
 if (has_capability('moodle/site:config', $systemcontext)) {
Index: grade/report/grader/settings.php
=========================================================
--- grade/report/grader/settings.php	(revision 1.34.2.6)
+++ grade/report/grader/settings.php	Thu Apr 16 09:31:42 CEST 2009
@@ -39,6 +39,9 @@
 $settings->add(new admin_setting_configcheckbox('grade_report_showquickfeedback', get_string('quickfeedback', 'grades'),
                                             get_string('configshowquickfeedback', 'grades'), 0));
 
+$settings->add(new admin_setting_configcheckbox('grade_report_fixedstudents', get_string('fixedstudents', 'grades'),
+                                            get_string('configfixedstudents', 'grades'), 0));
+
 $settings->add(new admin_setting_configselect('grade_report_aggregationview', get_string('aggregationview', 'grades'),
                                           get_string('configaggregationview', 'grades'), GRADE_REPORT_AGGREGATION_VIEW_FULL,
                                           array(GRADE_REPORT_AGGREGATION_VIEW_FULL => get_string('full', 'grades'),
Index: grade/report/grader/styles.php
=========================================================
--- grade/report/grader/styles.php	(revision 1.1.2.14)
+++ grade/report/grader/styles.php	Thu Apr 16 09:31:42 CEST 2009
@@ -1,237 +1,549 @@
 .flexible th {
-    white-space:normal;
+white-space:normal;
 }
 
 .gradestable th.user img {
-    width: 20px;
-    height: 20px;
-}
-
-.gradestable th.user, .gradestable th.range {
-    white-space: nowrap;
+width:20px;
+height:20px;
 }
 
-.grade-report-grader table#user-grades .catlevel1 {
-  background-color: #ffffff;
-}
 .grade-report-grader table#user-grades .catlevel2 {
-  background-color: #eeeeee;
-}
-.grade-report-grader table#user-grades .catlevel3 {
-  background-color: #dddddd;
+background-color:#f9f9f9;
 }
 
 .grade-report-grader table#user-grades td.overridden {
-  background-color: #EFD9B3;
+background-color:#ddd;
 }
 
 .grade-report-grader table#user-grades tr.avg td.cell {
-    background-color: #efefff;
+background-color:#efefff;
+font-weight:700;
+color:#00008B;
 }
 
 .grade-report-grader table#user-grades tr.odd td.cell {
-    background-color: #efefef;
+background-color:#efefef;
+white-space:nowrap;
 }
 
 .grade-report-grader table#user-grades tr.even td.overridden {
-  background-color: #F3E4C0; 
+background-color:#F3E4C0;
 }
 
 .grade-report-grader table#user-grades tr.odd td.overridden {
-  background-color: #EFD9A4;
+background-color:#EFD9A4;
 }
 
 .grade-report-grader table#user-grades tr.even td.excluded {
-  background-color: #EABFFF; 
+background-color:#EABFFF;
 }
 
 .grade-report-grader table#user-grades tr.odd td.excluded {
-  background-color: #E5AFFF;
+background-color:#E5AFFF;
 }
 
-.grade-report-grader table#user-grades tr.odd th.header { 
+.grade-report-grader table#user-grades tr.odd th.header {
-    background-color: #efefef;
-    background-image: none;
-}
-
-.grade-report-grader table#user-grades td.vmarked, .grade-report-grader table#user-grades tr.odd td.vmarked {
-    background-color: #ffcc33;
-}
-
-.grade-report-grader table#user-grades td.hmarked, .grade-report-grader table#user-grades tr.odd td.hmarked {
-    background-color: #ffff99;
-}
-
-.grade-report-grader table#user-grades td.hmarked.vmarked, .grade-report-grader table#user-grades tr.odd td.hmarked.vmarked{
-    background-color: #ffcc99;
-} 
-
-.grade-report-grader table#user-grades tr.groupavg td.cell {
-    background-color: #efffef;
+background-color:#efefef;
+background-image:none;
 }
 
 .grade-report-grader table#user-grades tr.groupavg td.cell {
-  font-weight: bold;
-  color: #006400;
+background-color:#efffef;
+font-weight:700;
+color:#006400;
 }
 
-.grade-report-grader table#user-grades tr.avg td.cell {
-  font-weight: bold;
-  color: #00008B;
-}
-
-.grade-report-grader table#user-grades td.cat,
-.grade-report-grader table#user-grades td.course {
-  font-weight: bold;
-}
-
-.grade-report-grader table#user-grades {
-    font-size: 80%;
+.grade-report-grader table#user-grades td.cat,.grade-report-grader table#user-grades td.course {
+font-weight:700;
 }
 
 .grade-report-grader table#user-grades {
-  border-width:1px;
-  border-style:solid;
-  margin-top: 20px;
+font-size:10px;
+width:auto;
+background-color:transparent;
+border-style:solid;
+border-width:1px;
+margin:20px 0 0;
 }
 
 .grade-report-grader #overDiv table {
-  margin: 0;  
+margin:0;
 }
 
 .grade-report-grader #overDiv table td.feedback {
-  border: 0px;
+border:0;
 }
+
 .grade-report-grader #overDiv .feedback {
-  background-color: #AABBFF;
-  color: #000000;
-  font-family: Verdana;
-  font-size: 70%;
-  font-weight: normal;  
+font-size:70%;
+background-color:#ABF;
+color:#000;
+font-family:Verdana;
+font-weight:400;
 }
 
 .grade-report-grader #overDiv .caption {
-  background-color: #5566CC;
-  color: #CCCCFF;
-  font-family: Arial;
-  font-size: 70%;
-  font-weight: bold;
+font-size:70%;
+background-color:#56C;
+color:#CCF;
+font-family:Arial;
+font-weight:700;
 }
 
-.grade-report-grader div.submit {
-  margin-top: 20px;
-  text-align: center;
+.grade-report-grader #overDiv .intersection {
+font-size:70%;
+background-color:#ABF;
+color:#000;
+font-family:Verdana;
+font-weight:400;
 }
 
-.grade-report-grader table#user-grades td {
-  border-width:1px;
-  border-style:solid;
+.grade-report-grader #overDiv .intersectioncaption {
+background-color:#56C;
+color:#CCF;
+font-family:Arial;
+font-weight:700;
 }
 
-.grade-report-grader table#user-grades tr.heading {
-  border-width:0px 0px 0px 0px;
-  border-style:solid;
+.grade-report-grader div.submit {
+margin-top:20px;
+text-align:center;
 }
 
-.grade-report-grader table#user-grades .heading td {
-  border-width:0px 0px 0px 0px;
-  border-style:solid;
+.grade-report-grader table#user-grades td {
+text-align:right;
+border-style:solid;
+border-width:0 1px 1px 0;
 }
 
 .grade-report-grader table#user-grades th.category {
-  border-width:1px 1px 0px 1px;
-  border-style:solid;
-  vertical-align: top;
+vertical-align:top;
+border-style:solid;
+border-width:1px 1px 0;
 }
 
 .grade-report-grader table#user-grades th.user {
-  border-width:0px 0px 1px 0px;
-  border-style:solid;
+text-align:left;
+border-style:solid;
+border-width:0 0 1px;
 }
 
 .grade-report-grader table#user-grades th.useridnumber {
-  border-width:0px 0px 1px 1px;
-  border-style:solid;
+border-style:solid;
+border-width:0 0 1px 1px;
 }
 
+.grade-report-grader table#user-grades th.categoryitem,.grade-report-grader table#user-grades th.courseitem,.grade-report-grader table#user-grades td.topleft {
+vertical-align:top;
+border-style:solid;
+border-width:0 1px;
+}
+
+.grade-report-grader table#user-grades th.category,
+.grade-report-grader table#user-grades th.item,
 .grade-report-grader table#user-grades th.categoryitem,
-.grade-report-grader table#user-grades th.courseitem,
-.grade-report-grader table#user-grades td.topleft {
-  border-width:0px 1px 0px 1px;
-  border-style:solid;
-  vertical-align: top;
+.grade-report-grader table#user-grades th.courseitem {
+height: 25px;
+}
+
+.grade-report-grader td,.grade-report-grader th {
+border-color:#CECECE;
 }
 
 .grade-report-grader table#participants th {
-  vertical-align: top; 
+vertical-align:top;
+width:auto;
 }
 
 .grade-report-grader table#user-grades td.fillerfirst {
-  border-width:0px 0px 0px 1px;
-  border-style:solid;
+border-style:solid;
+border-width:0 0 0 1px;
 }
 
 .grade-report-grader table#user-grades td.fillerlast {
-  border-width:0px 1px 0px 0px;
-  border-style:solid;
+border-style:solid;
+border-width:0 1px 0 0;
 }
 
-.grade-report-grader table#user-grades th.item {
-  border-width:1px 1px 1px 1px;
-  border-style:solid;
-  vertical-align: top;
+.grade-report-grader table#user-grades th.item ,
+.grade-report-grader table#user-grades th.categoryitem ,
+.grade-report-grader table#user-grades th.courseitem {
+border-bottom-color:#000;
+vertical-align:top;
+border-style:solid;
+border-width:1px;
 }
 
 .grade-report-grader div.gradertoggle {
-  display: inline;
-  margin-left: 20px;
+display:inline;
+margin-left:20px;
+}
+
+.grade-report-grader table#user-grades th.range {
+text-align:right;
+border-style:solid;
+border-width:1px;
+}
+
+.grade-report-grader table#user-grades .userpic {
+display:inline;
+margin-right:10px;
+}
+
+.grade-report-grader table#user-grades .quickfeedback {
+border:#000 1px dashed;
+}
+
+.grade-report-grader #siteconfiglink {
+text-align:right;
+}
+
+.grade-report-grader table#user-grades .hidden,.grade-report-grader table#user-grades .hidden a {
+color:#aaa;
+}
+
+.grade-report-grader table#user-grades .datesubmitted {
+font-size:.7em;
+}
+
+.grade-report-grader table#user-grades td.cell {
+padding-left:5px;
+padding-right:5px;
+vertical-align:middle;
+}
+
+.grade-report-grader table {
+border-collapse:collapse;
+background-color:#fff;
+font-size:10px;
+border-color:#cecece;
+}
+
+.grade-report-grader th {
+padding:2px 10px 0;
+}
+
+.grade-report-grader span.inclusion-links {
+margin:0 5px 0 10px;
+}
+
+.grade-report-grader table#user-grades .item {
+background-color:#e9e9e9;
+}
+
+.grade-report-grader table tr.odd th.header {
+background-color:#efefef;
+background-image:none;
+border-width:0 0 1px;
+}
+
+.grade-report-grader table tr.heading th.header {
+border-top:1px solid #cecece;
+}
+
+.grade-report-grader table#user-grades tr.heading th.categoryitem,.grade-report-grader table#user-grades tr.heading th.courseitem {
+border-width:0 0 0 1px;
+}
+
+.grade-report-grader table#user-grades th.category.header.catlevel1 {
+vertical-align:top;
+border-style:solid;
+border-width:1px 1px 0 0;
+}
+
+.grade-report-grader div.left_scroller th.user a {
+vertical-align:middle;
+margin:0;
+padding:0;
+}
+
+.grade-report-grader table#user-grades th.categoryitem,.grade-report-grader table#user-grades th.courseitem,.grade-report-grader table td.topleft {
+vertical-align:top;
+border-color:#cecece #cecece #000;
+border-style:solid;
+border-width:0 1px 1px;
+}
+
+.grade-report-grader table td.topleft {
+border-bottom:none;
+}
+
+.grade-report-grader table#user-grades td.topleft {
+background-color:#fff;
+}
+
+.grade-report-grader div.userpic {
+margin-right:10px;
+float:left;
+}
+
+.grade-report-grader div.userpic img {
+border:3px double #cecece;
+vertical-align:middle;
+width:2.7em;
+height:2.7em;
 }
 
-.grade-report-grader table#user-grades {
-  margin-left:auto;
-  margin-right:auto;
+.grade-report-grader a.quickedit {
+line-height:1em;
+display:block;
+float:right;
+clear:none;
+font-size:9px;
+background-color:transparent;
+margin:.1em 0 0;
+}
+
+.grade-report-grader a.quickedit2 {
+display:block;
+float:right;
+clear:none;
+background-color:transparent;
+margin:1.3em 0 0;
+}
+
+.grade-report-grader table#quick_edit {
+border:1px solid #cecece;
+margin:0 auto;
+}
+
+.grade-report-grader table#quick_edit td {
+vertical-align:middle;
+border:1px solid #cecece;
+text-align:left;
+margin:0;
+padding:5px;
+}
+
+.grade-report-grader table#quick_edit td img {
+border:3px double #cecece;
+vertical-align:middle;
+padding:0;
+}
+
+.grade-report-grader td input {
+border:1px solid #666;
+margin-left:10px;
+margin-right:10px;
+}
+
+.grade-report-grader table#quick_edit td.fullname {
+border-left:none;
+padding-left:5px;
+}
+
+.grade-report-grader table#quick_edit td.picture {
+border-right:none;
+}
+
+.grade-report-grader table#quick_edit td.finalgrade input {
+width:5em;
+}
+
+.grade-report-grader h1 {
+text-align:center;
+clear:both;
+}
+
+.grade-report-grader form {
+text-align:center;
+}
+
+.grade-report-grader input.center {
+margin:10px auto 0;
+}
+
+.grade-report-grader .lefttbody {
+width:auto;
+vertical-align:middle;
+}
+
+.grade-report-grader table#user-grades th.fixedcolumn {
+border:1px solid #cecece;
+vertical-align:middle;
+}
+
+.grade-report-grader table#fixed_column th {
+border:1px solid #cecece;
+vertical-align:middle;
+border-right-color:#000;
+}
+
+.grade-report-grader table#fixed_column {
+padding-top:20px;
+border-top:1px solid #cecece;
+background-color:#fff;
+}
+
+.grade-report-grader .left_scroller {
+float:left;
+clear:none;
+padding-top:20px;
+}
+
+.grade-report-grader .right_scroller {
+width:auto;
+clear:none;
+overflow-x:auto;
+}
+
+.grade-report-grader table tr.avg,.grade-report-grader table tr.groupavg td,.grade-report-grader table tr.avg td,.grade-report-grader table tr.groupavg th,.grade-report-grader table tr.avg th,.grade-report-grader table tr.controls_row,.grade-report-grader table tr.controls_row th,.grade-report-grader table tr.range_row,.grade-report-grader table tr.range_row th,div.right_scroller tr {
+height:2em;
+}
+
+.grade-report-grader table#user-grades tr.groupavg td.cell,.grade-report-grader tr.groupavg th.header {
+background-color:#efffef;
+}
+
+.grade-report-grader form td.excluded {
+color:red;
+}
+
+.grade-report-grader .excludedfloater {
+font-weight:700;
+color:red;
+font-size:9px;
+float:left;
+}
+
+.grade-report-grader span.gradepass {
+color:#298721;
+}
+
+.grade-report-grader span.gradefail {
+color:#890d0d;
+}
+
+.gradeweight {
+color:#461d7c;
+font-weight:700;
+}
+
+.grade-report-grader td select {
+font-size:100%;
+padding:0;
+}
+
+.grade-report-grader .righttest td select {
+font-size:86%;
+padding:0;
+}
+
+.grade-report-grader tr.avg,tr.controls,td.controls,th.controls,.grade-report-grader tr.groupavg,tr.range,th.range,td.range,tr.heading th.range {
+height:2em!important;
+white-space:nowrap;
+}
+
+.heading_name_row th {
+white-space:nowrap;
+width:2000px;
+}
+
+.ie .right_scroller {
+padding-bottom:15px;
+overflow-y:hidden;
+}
+
+.ie table#fixed_column th {
+height:40.5px;
+}
+
+.ie table#fixed_column tr.avg th {
+height:21px;
+}
+
+.ie div.left_scroller td {
+height:42px;
+}
+
+.ie6 div.left_scroller {
+margin-top:40px;
+}
+
+.ie6 div.right_scroller {
+margin-top:40px;
+width:auto;
+position:absolute;
+}
+
+.ie6 .excludedfloater {
+font-size:7px;
+}
+
+.grade_icons img.ajax {
+float:right;
+}
+
+.gradestable th.user,.gradestable th.range,.grade-report-grader .flexible th,.grade-report-grader .flexible td,.grade-report-grader .flexible th a,.grade-report-grader .flexible td a,.grade-report-grader .gradestable th.range,.grade-report-grader td {
+white-space:nowrap;
+}
+
+.grade-report-grader table#user-grades .catlevel1,.grade-report-grader .r1,.grade-report-grader table tr.even td.cell,.grade-report-grader table tr.even th {
+background-color:#fff;
+}
+
+.grade-report-grader table#user-grades .catlevel3,.grade-report-grader table tr.odd td.cell {
+background-color:#efefef;
 }
 
-.grade-report-grader table#user-grades  th.user {
-  text-align:left;
+.grade-report-grader table#fixed_column tr.odd th ,
+.grade-report-grader table#user-grades tr.odd th {
+background-color:#efefef;
 }
 
-.grade-report-grader table#user-grades  td.useridnumber {
-  text-align:left;
+.grade-report-grader table#user-grades td.vmarked,.grade-report-grader table#user-grades tr.odd td.vmarked,.grade-report-grader table#user-grades td.vmarked,.grade-report-grader table#user-grades tr.odd td.vmarked,.grade-report-grader table#user-grades tr.even td.vmarked {
+background-color:#fc3;
 }
 
-.grade-report-grader table#user-grades  td {
-  text-align:right;
+.grade-report-grader table#user-grades td.hmarked,.grade-report-grader table#user-grades tr.odd td.hmarked,.grade-report-grader table#user-grades td.hmarked,.grade-report-grader table#user-grades tr.odd td.hmarked,.grade-report-grader table#user-grades tr.even td.hmarked {
+background-color:#ff9;
 }
 
-.grade-report-grader table#user-grades th.range {
-  border-width:1px 1px 1px 1px;
-  border-style:solid;
+.grade-report-grader table#user-grades td.hmarked.vmarked,.grade-report-grader table#user-grades tr.odd td.hmarked.vmarked,.grade-report-grader table#user-grades td.hmarked.vmarked,.grade-report-grader table#user-grades tr.even td.hmarked.vmarked,.grade-report-grader table#user-grades tr.odd td.hmarked.vmarked {
+background-color:#fc9;
+}
+
+.grade-report-grader table#user-grades tr.heading,.grade-report-grader table#user-grades .heading td {
+border-style:solid;
+border-width:0;
 }
 
-.grade-report-grader table#user-grades .userpic {
-  display: inline;
-  margin-right: 10px;
+.grade-report-grader table#user-grades td.useridnumber,.grade-report-grader table#user-grades th,.grade-report-grader div.gradeparent,.ie6 form,.grade-report-grader table#user-grades td.ajax {
+text-align:left;
 }
 
-.grade-report-grader table#user-grades .quickfeedback {
-  border: #000000 1px dashed;
+.grade-report-grader table tr.avg td.cell,.grade-report-grader table#user-grades td.controls,.grade-report-grader table tr.avg,.grade-report-grader table tr.avg td,.grade-report-grader table tr.avg th {
+background-color:#f3ead8;
 }
 
-.grade-report-grader #siteconfiglink {
-  text-align: right;
+.grade-report-grader div.left_scroller tr,.grade-report-grader div.right_scroller tr,.grade-report-grader div.left_scroller td,.grade-report-grader div.right_scroller td,.grade-report-grader div.left_scroller th,.grade-report-grader div.right_scroller th {
+height:4em;
+font-size:10px;
 }
 
-.grade-report-grader table#user-grades .hidden,
-.grade-report-grader table#user-grades .hidden a {
-  color:#aaaaaa;
+.grade-report-grader table th.user,.grade-report-grader table td.useridnumber {
+text-align:left;
+vertical-align:middle;
 }
 
-.grade-report-grader table#user-grades .datesubmitted {
+.grade-report-grader .yui-overlay {
+    background-color: #FFEE69;
+    border-color: #D4C237 #A6982B #A6982B;
+    border-style: solid;
+    border-width: 1px;
+    left: 0;
+    padding: 2px 5px;
-  font-size: 0.7em;
+    font-size: 0.7em;
 }
 
-.grade-report-grader table#user-grades td.cell {
-  padding-left: 5px;
-  padding-right: 5px;
+.grade-report-grader .yui-overlay .fullname {
+    color: #5F3E00;
+    font-weight: bold;
+}
+.grade-report-grader .yui-overlay .itemname {
+    color: #194F3E;
+    font-weight: bold;
+}
+.grade-report-grader .yui-overlay .feedback {
+    color: #5F595E;
 }
Index: grade/report/lib.php
=========================================================
--- grade/report/lib.php	(revision 1.30.2.10)
+++ grade/report/lib.php	Thu Apr 16 09:31:42 CEST 2009
@@ -126,7 +126,6 @@
      */
     var $groupwheresql;
 
-
     /**
      * Constructor. Sets local copies of user preferences and initialises grade_tree.
      * @param int $courseid
@@ -156,6 +155,9 @@
         // roles to be displayed in the gradebook
         $this->gradebookroles = $CFG->gradebookroles;
 
+        // Set up link to preferences page
+        $this->preferences_page = $CFG->wwwroot.'/grade/report/grader/preferences.php?id='.$courseid;
+
         // init gtree in child class
     }
 
@@ -182,7 +184,7 @@
             } elseif (isset($CFG->$fullprefname)) {
                 $retval = get_user_preferences($fullprefname, $CFG->$fullprefname);
             } elseif (isset($CFG->$shortprefname)) {
-                $retval = get_user_preferences($fullprefname, $CFG->$shortprefname); 
+                $retval = get_user_preferences($fullprefname, $CFG->$shortprefname);
             } else {
                 $retval = null;
             }
@@ -308,10 +310,11 @@
      * @param string HTML
      */
     function get_sort_arrow($direction='move', $sort_link=null) {
-        $matrix = array('up' => 'asc', 'down' => 'desc', 'move' => 'desc');
+        $matrix = array('up' => 'desc', 'down' => 'asc', 'move' => 'desc');
         $strsort = $this->get_lang_string('sort' . $matrix[$direction]);
+
         $arrow = print_arrow($direction, $strsort, true);
-        $html = '<a href="'.$sort_link .'">' . $arrow . '</a>';
+        $html = '<a href="'.$sort_link .'" alt="'.$strsort.'" title="'.$strsort.'">' . $arrow . '</a>';
         return $html;
     }
 }
Index: grade/report/outcomes/index.php
=========================================================
--- grade/report/outcomes/index.php	(revision 1.11.2.3)
+++ grade/report/outcomes/index.php	Thu Apr 16 09:31:42 CEST 2009
@@ -38,16 +38,6 @@
 
 require_capability('gradereport/outcomes:view', $context);
 
-// Build navigation
-$strgrades = get_string('grades');
-$stroutcomes = get_string('outcomes', 'grades');
-
-$navigation = grade_build_nav(__FILE__, $stroutcomes, $course->id);
-
-/// Print header
-print_header_simple($strgrades.':'.$stroutcomes, ':'.$strgrades, $navigation, '', '', true);
-print_grade_plugin_selector($courseid, 'report', 'outcomes');
-
 //first make sure we have proper final grades
 grade_regrade_final_grades($courseid);
 
@@ -165,7 +155,9 @@
 
 
 $html .= '</table>';
-print_heading($stroutcomes);
+
+print_grade_page_head($courseid, 'report', 'outcomes');
+
 
 echo $html;
 print_footer($course);
Index: grade/report/overview/index.php
=========================================================
--- grade/report/overview/index.php	(revision 1.2.2.3)
+++ grade/report/overview/index.php	Thu Apr 16 09:31:42 CEST 2009
@@ -67,18 +67,6 @@
 }
 $USER->grade_last_report[$course->id] = 'overview';
 
-/// Build navigation
-$strgrades  = get_string('grades');
-$reportname = get_string('modulename', 'gradereport_overview');
-
-$navigation = grade_build_nav(__FILE__, $reportname, $course->id);
-
-/// Print header
-print_header_simple($strgrades.': '.$reportname, ': '.$strgrades, $navigation,
-                    '', '', true, '', navmenu($course));
-
-/// Print the plugin selector at the top
-print_grade_plugin_selector($course->id, 'report', 'overview');
 
 if ($access) {
 
@@ -87,9 +75,7 @@
 
     // Create a report instance
     $report = new grade_report_overview($userid, $gpr, $context);
-
-    // print the page
-    print_heading(get_string('modulename', 'gradereport_overview'). ' - '.fullname($report->user));
+    print_grade_page_head($courseid, 'report', 'overview', get_string('modulename', 'gradereport_overview'). ' - '.fullname($report->user));
 
     if ($report->fill_table()) {
         echo $report->print_table(true);
@@ -97,6 +83,15 @@
 
 } else {
     // no access to grades!
+    /// Print header
+    /// Build navigation
+    $strgrades  = get_string('grades');
+    $reportname = get_string('modulename', 'gradereport_overview');
+
+    $navigation = grade_build_nav(__FILE__, $reportname, $course->id);
+    print_header_simple($strgrades.': '.$reportname, ': '.$strgrades, $navigation,
+                        '', '', true, '', navmenu($course));
+
     echo "Can not view grades."; //TODO: localize
 }
 print_footer($course);
Index: grade/report/user/index.php
=========================================================
--- grade/report/user/index.php	(revision 1.26.2.9)
+++ grade/report/user/index.php	Thu Apr 16 09:31:42 CEST 2009
@@ -71,19 +71,6 @@
 }
 $USER->grade_last_report[$course->id] = 'user';
 
-/// Build navigation
-$strgrades  = get_string('grades');
-$reportname = get_string('modulename', 'gradereport_user');
-
-$navigation = grade_build_nav(__FILE__, $reportname, $courseid);
-
-/// Print header
-print_header_simple($strgrades.': '.$reportname, ': '.$strgrades, $navigation,
-                    '', '', true, '', navmenu($course));
-
-/// Print the plugin selector at the top
-print_grade_plugin_selector($courseid, 'report', 'user');
-
 
 if ($access) {
 
@@ -92,41 +79,47 @@
 
     if (has_capability('moodle/grade:viewall', $context)) { //Teachers will see all student reports
         /// Print graded user selector at the top
-        echo '<div id="graded_users_selector">';
-        print_graded_users_selector($course, 'report/user/index.php?id=' . $course->id, $userid);
-        echo '</div>';
-        echo "<p style = 'page-break-after: always;'></p>";
+        $user_selector = '<div id="graded_users_selector">';
+        $user_selector .= print_graded_users_selector($course, 'report/user/index.php?id=' . $course->id, $userid, true);
+        $user_selector .= '</div>';
+        $user_selector .= "<p style = 'page-break-after: always;'></p>";
 
         if ($userid === 0) {
             $gui = new graded_users_iterator($course);
             $gui->init();
+            // Add tabs
+            print_grade_page_head($courseid, 'report', 'user');
+
+            echo $user_selector.'<br />';
             while ($userdata = $gui->next_user()) {
                 $user = $userdata->user;
                 $report = new grade_report_user($courseid, $gpr, $context, $user->id);
                 print_heading(get_string('modulename', 'gradereport_user'). ' - '.fullname($report->user));
+
                 if ($report->fill_table()) {
-                    echo $report->print_table(true);
+                    echo '<br />'.$report->print_table(true);
                 }
                 echo "<p style = 'page-break-after: always;'></p>";
             }
             $gui->close();
         } elseif ($userid) { // Only show one user's report
             $report = new grade_report_user($courseid, $gpr, $context, $userid);
-            print_heading(get_string('modulename', 'gradereport_user'). ' - '.fullname($report->user));
+            print_grade_page_head($courseid, 'report', 'user', get_string('modulename', 'gradereport_user'). ' - '.fullname($report->user));
+            echo $user_selector;
             if ($report->fill_table()) {
-                echo $report->print_table(true);
+                echo '<br />'.$report->print_table(true);
-            } 
+            }
         }
-    } else { //Students will see just their own report 
+    } else { //Students will see just their own report
 
         // Create a report instance
         $report = new grade_report_user($courseid, $gpr, $context, $userid);
 
         // print the page
-        print_heading(get_string('modulename', 'gradereport_user'). ' - '.fullname($report->user));
+        print_grade_page_head($courseid, 'report', 'user', get_string('modulename', 'gradereport_user'). ' - '.fullname($report->user));
 
         if ($report->fill_table()) {
-            echo $report->print_table(true);
+            echo '<br />'.$report->print_table(true);
         }
     }
 
